unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    CS:TRTLCriticalSection;
  public
    { Public declarations }
    procedure LockForm;
    procedure UnlockForm;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//  .
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   Memo1.Lines.Clear;
end;

//   .
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
       Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
end;

//   .
procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
   if SaveDialog1.Execute then
       Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

// .
procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.LockForm;
begin
  EnterCriticalSection(CS);
end;

procedure TForm1.UnlockForm;
begin
  LeaveCriticalSection(CS);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitializeCriticalSection(CS);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeleteCriticalSection(CS); 
end;

end.
